import { Children, cloneElement, } from "react";
import copy from "copy-to-clipboard";
export const CopyToClipboard = ({ text, children, onCopy, options, }) => {
    const handleCopy = () => {
        const result = copy(text, options);
        if (onCopy) {
            onCopy(text, result);
        }
        return result;
    };
    const handleCopyClick = (event) => {
        handleCopy();
        // Bypass onClick if it was present
        if (children.props && typeof children.props.onClick === "function") {
            children.props.onClick(event);
        }
    };
    const handleCopyKeyDown = (event) => {
        if (event.key === "Enter") {
            handleCopy();
        }
        // Bypass onKeyDown if it was present
        if (children.props && typeof children.props.onKeyDown === "function") {
            children.props.onKeyDown(event);
        }
    };
    const onClick = (event) => {
        handleCopyClick(event);
    };
    const onKeyDown = (event) => {
        handleCopyKeyDown(event);
    };
    const elem = Children.only(children);
    return cloneElement(elem, Object.assign(Object.assign({ tabIndex: 0 }, (children.props || {})), { onClick,
        onKeyDown }));
};
//# sourceMappingURL=index.js.map